import wx
import os
import fnmatch
import subprocess
ID_GETDIR=1
ID_GEN=2

onlyfiles =[]
t2d=0

class t2dconvert(wx.Frame):
    def __init__(self, *args, **kwargs):
        super(t2dconvert, self).__init__(*args, **kwargs)
        self.InitUI()
    def InitUI(self):
        self.currentDirectory = path = os.path.expanduser("~/Desktop/")
        panel = wx.Panel(self, -1)
        graphpanel = wx.Panel(panel, -1, style=wx.FULL_REPAINT_ON_RESIZE)
        self.t2dfilepath = wx.TextCtrl(graphpanel, value=self.currentDirectory, pos=(5,5), size=(260,25))
        #self.gauge = wx.Gauge(graphpanel, -1, 100, pos=(5,75), size=(290,20))
        getdirectory = wx.Button(graphpanel, ID_GETDIR, '...', pos=(260, 0), size=(30,30))
        generate = wx.Button(graphpanel, ID_GEN, 'Generate .mzXML file',pos=(5,30), size=(290,30))
        self.Bind(wx.EVT_BUTTON, self.convert, id=ID_GEN)
        self.Bind(wx.EVT_BUTTON, self.onChangeDir, id=ID_GETDIR)
        hbox = wx.BoxSizer(wx.HORIZONTAL)
        hbox.Add(graphpanel, 1, wx.EXPAND | wx.ALL, 10)
        
        panel.SetSizer(hbox)
        self.SetSize ((325,110))
        self.SetTitle ('T2D Converter by Bathy@Scripps')
        self.Centre()
        self.SetWindowStyle(wx.DEFAULT_FRAME_STYLE ^ wx.RESIZE_BORDER)
        #Mac Specific start
        self.SetMaxSize((325,110))
        self.SetMinSize((325,110))
        #Mac Specific end
        self.Show(True)
            
    def onChangeDir(self, e):
        dlg = wx.DirDialog(self, message="Please select the directory of T2Ds, all subdirectories will be searched", defaultPath=self.t2dfilepath.GetValue(),)
        if dlg.ShowModal() == wx.ID_OK:
            path = dlg.GetPath()
        else:
            path=""
        if path!="":
            self.t2dfilepath.SetValue(path)
        dlg.Destroy()

    def convert(self, e):
        #onlyfiles = [ f for f in os.listdir(self.t2dfilepath.GetValue()) if os.path.isfile(os.path.join(self.t2dfilepath.GetValue(),f))&f.endswith('t2d') ]
        global onlyfiles
        global t2d
        for root, dirnames, filenames in os.walk(self.t2dfilepath.GetValue()):
            for filename in fnmatch.filter(filenames, '*.t2d'):
              onlyfiles.append(os.path.join(root, filename))
            for filename in fnmatch.filter(filenames, '*.T2D'):
              onlyfiles.append(os.path.join(root, filename))
            for filename in fnmatch.filter(filenames, '*.T2d'):
              onlyfiles.append(os.path.join(root, filename))
            for filename in fnmatch.filter(filenames, '*.t2D'):
              onlyfiles.append(os.path.join(root, filename))
        if len(onlyfiles) != 0:
                self.SetTitle('Processing '+str(len(onlyfiles))+' files...')
        while t2d < len(onlyfiles):
            #os.system('java org.proteomecommons.io.util.ConvertPeakList -merge '+'"'+onlyfiles[t2d]+'" "'+onlyfiles[t2d]+'.mzxml"')
            #command='java org.proteomecommons.io.util.ConvertPeakList -merge '+'"'+onlyfiles[t2d]+'" "'+onlyfiles[t2d]+'.mzxml"'
            self.process()
            t2d+=1
            #self.gauge.SetValue(t2d/len(onlyfiles)*100)
            #subprocess.check_call(command, shell=True)
            #h.wait()
            #os.spawnl(os.P_NOWAIT, command)
            #self.launchWithoutConsole(command)
        if len(onlyfiles) !=0:
            self.SetTitle('Completed')
            del onlyfiles[:]
            t2d=0
        else:
            self.SetTitle('No T2D file found')
    def process(self):
        self.SetTitle('Processing '+str(t2d)+'/'+str(len(onlyfiles))+' files...')
        self.Layout()
        command='java org.proteomecommons.io.util.ConvertPeakList -merge '+'"'+onlyfiles[t2d]+'" "'+onlyfiles[t2d]+'.mzxml"'
        proc=subprocess.Popen(command, shell=True)
        return True


        
ex = wx.App()
t2dconvert(None)
ex.MainLoop()
